///////////////////////////////////////////////////////////////
// APItbN֘AW[
///////////////////////////////////////////////////////////////

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include "dlldebug.h"
#include "apihook.h"


///////////////////////////////////////////////////////////////
// p}N
#define ERRMSG				DebugMsg		// G[bZ[W


///////////////////////////////////////////////////////////////
// APItbN̏
// 
// @ModuleName			ΏAPI݂郂W[
// @FunctionName		Ώۊ֐
// @HookInfo			tbN񂪊i[
// ߂l
// @0					
// @0ȊO				s
int SetupAPIHook( const char *ModuleName, const char *FunctionName, APIHOOKINFO &HookInfo )
{
	// NA
	HookInfo.Thunk			= NULL;
	HookInfo.OrignalAdrs	= NULL;

	// ֐̃AhX擾
	HMODULE	hMod = GetModuleHandle( ModuleName );
	if( hMod == NULL )
	{
		ERRMSG( "ΏۃW[(%s)̓[hĂ܂B", ModuleName );
		return 1;
	}
	DWORD	funcadrs;
	funcadrs = (DWORD)GetProcAddress( hMod, FunctionName );
	if( funcadrs == 0 )
	{
		ERRMSG( "Ώۊ֐(%s)݂͑܂B", FunctionName );
		return 1;
	}

	// DOSwb_擾
	PIMAGE_DOS_HEADER	dosh;
	dosh = (PIMAGE_DOS_HEADER)GetModuleHandle( NULL );
	if( dosh == NULL )
	{
		ERRMSG( "DOSwb_ւ̃ANZX܂B" );
		return 1;
	}
	if( dosh->e_magic != IMAGE_DOS_SIGNATURE )
	{
		ERRMSG( "LDOSwb_ł͂܂B" );
		return 1;
	}

	// NTwb_擾
	PIMAGE_NT_HEADERS	nth;
	nth = (PIMAGE_NT_HEADERS)RVAtoVA( dosh, (void *)(dosh->e_lfanew) );
	if( IsBadReadPtr( nth, sizeof(PIMAGE_NT_HEADERS) ) )
	{
		ERRMSG( "NTwb_ւ̃ANZX܂B" );
		return 1;
	}
	if( nth->Signature != IMAGE_NT_SIGNATURE )
	{
		ERRMSG( "LNTwb_ł͂܂B" );
		return 1;
	}

	// ImportZNV烂W[
	PIMAGE_IMPORT_DESCRIPTOR	impinfo;
	impinfo = (PIMAGE_IMPORT_DESCRIPTOR)RVAtoVA( dosh, (void *)(nth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress) );
	while( impinfo->FirstThunk != NULL )
	{
		char *dllname = (char *)RVAtoVA( dosh, (void *)( impinfo->Name ) );
		if( ! _stricmp( dllname, ModuleName ) )
		{
			// 
			break;
		}
		impinfo++;
	}
	if( impinfo->Name == NULL )
	{
		ERRMSG( "ΏۃW[(%s)܂B", ModuleName );
		return 1;
	}

	// e[u
	PIMAGE_THUNK_DATA	tnk;
	tnk = (PIMAGE_THUNK_DATA)RVAtoVA( dosh, (void *)impinfo->FirstThunk );
	while( tnk->u1.Function != NULL )
	{
		if( tnk->u1.Function == funcadrs )
		{
			// 
			HookInfo.Thunk			= tnk;
			HookInfo.OrignalAdrs	= tnk->u1.Function;
			return 0;
		}

		tnk++;
	}

	// ֐炸EEE
	ERRMSG( "Ώۊ֐(%s)܂B", FunctionName );
	return 1;
}

// ItZbg΃AhX擾
void *RVAtoVA( void *Base, void *Offset )
{
	return (void *)((unsigned int)Base + (unsigned int)Offset);
}



///////////////////////////////////////////////////////////////
// tbNL
// 
// @HookInfo				tbN
void EnableHook( APIHOOKINFO &HookInfo )
{
	// `FbN
	if( HookInfo.Thunk == NULL )		return;

	// ĂяoƎ̊֐ɂ
	UpdateFunctionAddress( &HookInfo.Thunk->u1.Function, HookInfo.CustomAdrs );
}

// tbN
// 
// @HookInfo				tbN
void DisableHook( APIHOOKINFO &HookInfo )
{
	// `FbN
	if( HookInfo.Thunk == NULL )		return;

	// Ăяo{̊֐ɂ
	UpdateFunctionAddress( &HookInfo.Thunk->u1.Function, HookInfo.OrignalAdrs );
}

// Sȃf[^̏
// 
// @Address				ރAhX
// @Data					݃f[^
void UpdateFunctionAddress( void *Address, DWORD Data )
{
	HRESULT rc;

	// `FbN
	if( Address == NULL )		return;

	// ݉\ɂ
	DWORD oldprotect;
	rc = VirtualProtect( Address, 4, PAGE_READWRITE , &oldprotect );
	if( rc == 0 )
	{
		DebugPrint( "̃veNgύXł܂BAdrs = %08x\n", (DWORD)Address );
		return;
	}

	// 
	*(DWORD *)Address = Data;
	
	// veNg߂
	rc = VirtualProtect( Address, 4, oldprotect, &oldprotect );
	if( rc == 0 )
	{
		DebugPrint( "̃veNg߂܂BAdrs = %08x , %08x\n", (DWORD)Address, oldprotect );
		return;
	}
}
