///////////////////////////////////////////////////////////////
// fobOpW[
///////////////////////////////////////////////////////////////

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "dlldebug.h"


///////////////////////////////////////////////////////////////
// W[ϐ
static CRITICAL_SECTION		mCS;						// NeBJZNV
static bool					mCSInitialized = false;		// NeBJZNVς


///////////////////////////////////////////////////////////////
// p}N

#define FORMATTEXT( fmt, buff )			\
	{ \
		va_list argp; \
		va_start( argp, fmt ); \
		if( vsnprintf_s( buff, DLLDEBUG_MAXTEXTLEN, _TRUNCATE, fmt, argp ) < 0 ) \
			buff[ DLLDEBUG_MAXTEXTLEN - 1 ] = '\0'; \
		va_end( argp ); \
	}


///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

// fobOo̓bN
void DebugPrintLock()
{
	// NeBJZNVm
	if( ! mCSInitialized )
	{
		InitializeCriticalSection( &mCS );
		mCSInitialized = true;
	}
	EnterCriticalSection( &mCS );
}

// fobOo̓AbN
void DebugPrintUnlock()
{
	// NeBJZNV
	LeaveCriticalSection( &mCS );
}



// fobOo
// 
// @Fmt			
// @...			Xg
void DebugPrint( const char* Fmt, ... )
{
	// WJ
	char	wk[DLLDEBUG_MAXTEXTLEN];
	FORMATTEXT( Fmt, wk );

	// Ot@C`FbN
	if( DLLDEBUG_LOGFILE != NULL )
	{
		// Ot@CI[v
		FILE	*fp = NULL;
		fopen_s( &fp, DLLDEBUG_LOGFILE, "a" );
		if( fp == NULL )
		{
			MessageBoxA( NULL, wk, "fobOpOt@CI[vł܂B", MB_OK );
		} else
		{
			// Oo
			fprintf( fp, wk );
			fflush( fp );
			fclose( fp );
		}
	}
}

// ݎ̏o
void DebugPrintNow()
{
	// ݎ̎擾
	time_t	lt;
	time( &lt );
	struct tm nt;
	localtime_s( &nt, &lt );

	// o
	DebugPrint( "%02d:%02d:%02d ", nt.tm_hour, nt.tm_min, nt.tm_sec );
}



// fobOpbZ[W\
// 
// @Fmt			
// @...			Xg
void DebugMsg( const char* Fmt, ... )
{
	// WJ
	char	wk[DLLDEBUG_MAXTEXTLEN];
	FORMATTEXT( Fmt, wk );

	// fobOo
	DebugPrintLock();
	DebugPrintNow();
	DebugPrint( wk );
	DebugPrint( "\n" );
	DebugPrintUnlock();

	// bZ[W\
	MessageBoxA( NULL, wk, "DLL Debug", MB_OK );
}
